      -------------------- Définition des variables --------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
local addonName = "GearHelper"
local version = GetAddOnMetadata(addonName, "Version")
local versionCible = nil
--print("Version actuelle : "..version)
local rappelVersion = 3 -- permet de ne pas afficher toutes les 5 minutes le message d'addon périmé (surtout vrai en guilde)
local prefix = "GeARHeLPeRPReFIX"--..version -- rajouter version si on veut que notre addon ne comunique QUE avec les GH de la même version
-- ^ Pour le préfix, choisir un nom qu'on est sûr que personne d'autre ne réutilisera
local L = GearHelperLocalization -- permet de récupérer le text dans toutes les langues

local allEvents = {}
local allPrefix = {["askVersion"..prefix] = sendAnswerVersion, ["answerVersion"..prefix] = receiveAnswer,}
local nbSlotsBag = {[0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0}
local eventHandler, waitAnswerFrame, loadFrame = CreateFrame("Frame"), CreateFrame("Frame"), CreateFrame("Frame")
local askTime, maxWaitTime = nil, 15
local bagInventory = {}
local charInventory = {}
-- NE PAS OUBLIER DE RAJOUTER LA VERSION PRÉCÉDENTE ICI APRÈS CHAQUE MISE A JOUR !!!!
local anciennesVersions = {"0.0", "0.1", "0.2",}
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
      ----------------- Fin de définition des variables -----------------
      waitAnswerFrame:Hide()

-- Initialise la variable sur true la première fois qu'on utilise l'addon
-- Variable par perso, permet d'avoir différents profils
local function setDefault()
	GHActivated = true
end

-- desc : Permet de changer l'état (on / off) de l'addon
-- entrée : booleen (true / false)
-- sortie : string (message indiquant si l'addon est sur on ou off)
-- commentaire :
local function setActivated( valeur )
	if valeur == true then
		GHActivated = true
		print(L["setOn"])
		elseif valeur == false then
			GHActivated = false
			print(L["setOff"])
		else
			print(L["errorSetActivatedValue"])
		end
	end

-- desc : Envoie dans la guilde / raid / groupe une demande aux autres GH pour savoir s'ils sont à jour
-- entrée : ø
-- sortie : ø
-- commentaire :
local function sendAskVersion()
	if UnitInRaid("player") ~= nil then
		SendAddonMessage(prefix, "askVersion;"..version, "RAID")
	end
	if IsInGuild() == true then
		SendAddonMessage(prefix, "askVersion;"..version, "GUILD")
	end
	if UnitInParty("player") then
		SendAddonMessage(prefix, "askVersion;"..version, "PARTY")
	end
	askTime = time()
	waitAnswerFrame:Show()
end

-- desc : Quand on reçoit une demande de version, l'addon utilise cette fonction qui envoit la réponse
-- entrée : ø
-- sortie : ø
-- commentaire :
local function sendAnswerVersion()
	if UnitInRaid("player") ~= nil then
		SendAddonMessage(prefix, "answerVersion;"..version, "RAID")
	end
	if IsInGuild() then
		SendAddonMessage(prefix, "answerVersion;"..version, "GUILD")
	end
	if UnitInParty("player") then
		SendAddonMessage(prefix, "answerVersion;"..version, "PARTY")
	end
end

-- desc : Vérifie si l'addon est à jour quand il recoit une réponse 
-- entrée : string (version de la cible), string (nom de la cible)
-- sortie : string (message si l'addon n'est pas à jour, sinon rien)
-- commentaire :
local function receiveAnswer( msgV, msgC )
	if askTime then
		local answerCible = msgC:sub(msgC:find("-") - 1, #msgC)
		if rappelVersion >= 0 then
			if anciennesVersions[msgV] == nil then
				if versionCible ~= version then
					if L["local"] == "FR" then
						wait(15, print("Vous utilisez la version |cFFFF0000"..version.."|r de GearHelper. La version |cFF00FF00"..msgV.."|r a été trouvée chez "..msgC), time())
					elseif L["local"] == "US" or L["local"] == "DE" then
						wait(15, print("You are using version |cFFFF0000"..version.."|r of GearHelper. Version |cFF00FF00"..msgV.."|r was find from "..msgC), time())
					end
					askTime = nil
					waitAnswerFrame:Hide()
					rappelVersion = rappelVersion - 1
				end
			end
		end
	end
end
waitAnswerFrame:SetScript("OnUpdate", function ( self, elapsed )
	if askTime and (time() - askTime) > maxWaitTime then
		askTime = nil
		waitAnswerFrame:Hide()
	end
end)


-------------------------------------------------------------------------------
								-- FONCTIONS --
-------------------------------------------------------------------------------

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :
local function testSiObjetGris( itemID ) -- itemID ou itemLink ou itemName ou itemString
	local _, _, itemRarity, _, _, _, _, _, _, _, _ = GetItemInfo(itemID)
	if itemRarity == 0 then
		return true
	else 
		return false
	end
	if itemRarity == nil then 
		return false
	end
end

-- desc :
-- entrée :
-- sortie :
-- commentaire : creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected, mountID  = C_MountJournal.GetDisplayedMountInfo(i)
local function testSiMonture( idMonture )
	local i = 1
	local creatureName, spellID, _, _, _, _, _, _, _, _, _, _  = C_MountJournal.GetDisplayedMountInfo(i)
	while creatureName ~= nil do
		if spellID == idMonture then
			return true
		end
		i = i + 1
		creatureName, spellID, _, _, _, _, _, _, _, _, _, _  = C_MountJournal.GetDisplayedMountInfo(i)
	end 
	return false
end

-- desc : Comme son nom l'indique permet d'effectuer une pause avant 
-- entrée : int(durée d'attente), func(la fonction a effectuer après l'attente)
-- sortie : l'exécution de la fonction passée en entré
-- commentaire :
local function wait( duree, fonction, timer )
	local waitFrame = CreateFrame("Frame")

	waitFrame:SetScript("OnUpdate", function ( self, elapsed )
		if time() >= timer + duree then
			if fonction then
				fonction()
			end
			waitFrame:Hide()
		end
		end)
end

-- desc : Cette fonction permet de récupérer le nombre de slots dans l'inventaire du joueur
-- entrée : ø
-- sortie : ø
-- commentaire :
local function nbSlotsTotal()
	local nbSlots = 0
	local i = 0
	while i <= 4 do
		if GetContainerNumSlots(i)  then
			nbSlots = nbSlots + GetContainerNumSlots(i)
		end
		i = i + 1
	end
	return nbSlots
end

-- desc : Inventoriage des sacs
-- entrée : 
-- sortie : 
-- commentaire :
local function scanBag()
	local count = 0
	for bag = 0,4 do
    	for slot = 1,GetContainerNumSlots(bag) do
			local itemID = GetContainerItemLink(bag, slot)
    		--Faire un getinventoryitemid pour tester si y'a bien un item et ensuite getinventoryitemlink pour recup le lien et non pas l'id de transmog
	  		if itemID ~= nil then
          		table.insert(bagInventory, parseID(itemID))
				count  = count + 1
	  		end
    	end
  	end
end

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :
local function scanCharacter()
    local count = 0
    if GetInventoryItemLink("player",GetInventorySlotInfo("HeadSlot")) ~= nil then
      charInventory["Head"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("HeadSlot")))
    else
      charInventory["Head"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("NeckSlot")) ~= nil then
      charInventory["Neck"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("NeckSlot")))
      else
      charInventory["Neck"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("ShoulderSlot")) ~= nil then
     charInventory["Shoulder"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("ShoulderSlot")))
      else
      charInventory["Shoulder"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("BackSlot")) ~= nil then
      charInventory["Back"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("BackSlot")))
      else
      charInventory["Back"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("ChestSlot")) ~= nil then
      charInventory["Chest"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("ChestSlot")))
      else
      charInventory["Chest"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("WristSlot")) ~= nil then
      charInventory["Wrist"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("WristSlot")))
      else
      charInventory["Wrist"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("HandsSlot")) ~= nil then
      charInventory["Hands"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("HandsSlot")))
      else
      charInventory["Hands"] =  0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("WaistSlot")) ~= nil then
      charInventory["Waist"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("WaistSlot")))
      else
      charInventory["Waist"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("LegsSlot")) ~= nil then
      charInventory["Legs"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("LegsSlot")))
      else
      charInventory["Legs"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("FeetSlot")) ~= nil then
      charInventory["Feet"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("FeetSlot")))
      else
      charInventory["Feet"] =  0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("Finger0Slot")) ~= nil then
      charInventory["Finger0"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("Finger0Slot")))
      else
      charInventory["Finger0"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("Finger1Slot")) ~= nil then
      charInventory["Finger1"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("Finger1Slot")))
      else
      charInventory["Finger1"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("Trinket0Slot")) ~= nil then
      charInventory["Trinket0"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("Trinket0Slot")))
      else
      charInventory["Trinket0"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("Trinket1Slot")) ~= nil then
      charInventory["Trinket1"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("Trinket1Slot")))
      else
      charInventory["Trinket1"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot")) ~= nil then
      charInventory["MainHand"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot")))
      else
      charInventory["MainHand"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot")) ~= nil then
      charInventory["SecondaryHand"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot")))
      else
      charInventory["SecondaryHand"] = 0
    end
end

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :
local function parseID(link)
  local a = string.match(link, "item[%-?%d::]+")
  local b = string.sub(a, 5, 12)
  local c = string.gsub(b, ":", "")
  return c
end
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

----------------------
-- Helper functions --				Pour ceux qui se demandent, oui, je dessine mieux en ASCII que je ne code
----------------------
--local function getCommand( command, instruction)
--	return "|cFFFF7D0A"..command.." : |r"..instruction
--end

--------------------
-- Slash commands --
--------------------
local allCommands = {
	--void = "|cFFFFFF00Tapez |cFF00FF00/gh|r|cFFFFFF00 ou |cFF00FF00/gh help|r|cFFFFFF00 pour voir l'aide|r",
	on = L["onHelpInfo"],
	off = L["offHelpInfo"],
	state = L["stateHelpInfo"],
}

local slashCmdFunc = {
	voidcommand = function ( msg )
		print("|cFFFFFF00Tapez |cFF00FF00/gh|r|cFFFFFF00 ou |cFF00FF00/gh help|r|cFFFFFF00 pour voir l'aide|r")
	end,
	on = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	enable = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	activated = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	off = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	disable = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	deactivated = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	help = function ( msg )
		print(allCommands.on)
		print(allCommands.off)
		print(allCommands.state)
	end,
	state = function ( msg )
		if GHActivated == true then
			print("|cFF00FF00GearHelper|r |cFFFFFF00est|r|cFF0000FF activé")
		else
			print("|cFF00FF00GearHelper|r |cFFFFFF00est|r|cFFFF0000 désactivé")
		end
	end,
	list = function ( msg )
		scanBag()
	 	scanCharacter()
	 	for k, v in pairs( charInventory ) do
	   		print(k, v)
		end
	 	for a = 1, #bagInventory do
	    	print(bagInventory[a])
	  	end
	end,
}

-- Activation de /cmd
local cmd1 = "/gh"
local cmd2 = "/gearhelper"
SLASH_GEARHELPER1 = cmd1:lower()
SLASH_GEARHELPER2 = cmd2:lower()
-- Fin d'activation des /cmd
-- Déclaration des /cmd
SlashCmdList["GEARHELPER"] = function ( msg )
	local instruction = msg:match("%a+")
	if instruction then 
		instruction = instruction:lower() 
	end
	if msg == "" then
		slashCmdFunc["help"](msg)
	elseif slashCmdFunc[instruction] then
		slashCmdFunc[instruction](msg)
	else
		slashCmdFunc["voidcommand"](msg)
	end
--end
end
-- Fin déclaration des /cmd

-------------------
-- Event handler --
-------------------

-- Se déclenche quand les addons se chargent
function allEvents:ADDON_LOADED( name )
	if name == addonName then
		-- charge le préfix de l'addon (ou un truc du genre)
		RegisterAddonMessagePrefix(prefix) 

		-- Active l'addon par défaut lors de la première connexion après l'installation
		if GHActivated == nil then
			setDefault() 
		end

		-- Affiche à chaque connection l'état de l'addon
		if GHActivated == true then 
			print(L["setOn"]) 
			--sendAskVersion()
		else 
			print(L["setOff"]) 
		end
	end
end

-- Se déclenche quand un message d'addon arrive
function allEvents:CHAT_MSG_ADDON( prefixMessage, message, channel, sender )
	local emeteur = sender:sub(0, (sender:find("-") - 1))
	local prefVersion = message:sub(0, (message:find(";") - 1))
	if GHActivated == true then
		if emeteur ~= GetUnitName("player") then
			if prefixMessage == prefix then
				if prefVersion == "answerVersion" then
				local vVersion = message:sub(message:find(";")+1, #message)
				versionCible = vVersion
				receiveAnswer(vVersion, sender)
			end
			if prefVersion == "askVersion" then
				sendAnswerVersion()
			end
		end
	end
end
end

-- Quand un objet attérie dans l'inventaire --bag : 0, 1, 2, 3 ou 4
function allEvents:ITEM_PUSH( bag )
	-- body
	--print(bag)
end

-- Evenement se déclenche quanduand un arrive sur la page de la quête terminée (la ou il faut choisir la récompense)
function allEvents:QUEST_COMPLETE()
	-- body
end

-- Evenement se déclenche à chaque écran de chargement
function allEvents:PLAYER_ENTERING_WORLD()
	if GHActivated == true then
		sendAskVersion()
	end
end

-- Evenement se déclanche quand la fenêtre besoin/cupi pop en donjon
function allEvents:START_LOOT_ROLL(number)
	-- number = ID de l'objet à roll
	-- rollType = 0 pass, 1 need, 2 cupi
	-- ConfirmLootRoll(number, rollType)

	if testSiMonture(number) then
		ConfirmLootRoll(number, 1)
	end
end
function allEvents:UNIT_INVENTORY_CHANGED( joueur )
	-- print("Joueur : "..joueur)
end

-- Evenement se déclenche quand on ouvre la fenetre d'un vendeur
function allEvents:MERCHANT_SHOW()
	for bag = 0,4 do
    	for slot = 1,GetContainerNumSlots(bag) do
	  		if GetContainerItemID(bag, slot) ~= nil then
	  			id = GetContainerItemID(bag, slot)
				if id then
					if testSiObjetGris(id) then
						UseContainerItem(bag, slot)
					end
				end
			end
    	end
  	end
end
--------------------------------------------
-- xxxxx xxxxxxx --      -- xxxxx xxxxxxx --
--------------------------------------------

for event, _ in pairs(allEvents) do
	eventHandler:RegisterEvent(event)
end
eventHandler:SetScript("OnEvent", function ( self, event, ... )
	if GHActivated == true or GHActivated == nil then
		allEvents[event](self, ...)
	end
	end)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------


--------------



-- pour chaques piece de stuff
-- faire une recherche dans l'inventaire
-- regarder s'il existe un stuff du même type
-- si oui, regarder s'il est meilleurs que celui qu'on à
-- si oui l'équiper
-- si non, le laisser dans l'inventaire


-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :


